<?
		$rubrique = 18;
		$meta_description = "";
		$meta_keywords = "";
		$titre_page = "Le systme de fichiers";
		$urlCss = "./article.css";
		$xhtml=true;
        
		$dateBrute['date'] = '6 Juin 2006';
		$dateBrute['miseajour'] = '';
		
				$topicType = 'Whitepaper';
			include("$DOCUMENT_ROOT/template/entete.php");
		?>
		  <div style="text-align:center;">
		  <table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
			<tr>
			  <td align="center" style="text-align:left">
	<br/><h1>Le systme de fichiers</h1><p class="dateArticle">
		Date de publication : 6 Juin 2006</p><p style="text-align: center;">
        Par
        <a class="auteur" href="http://www.developpez.net/forums/member.php?u=63956">Romain Guy (Gfx)</a> <a class="homepage" href="http://gfx.developpez.com/"> (home)</a><br/>&nbsp;</p><div class="synopsis">
        Un systme Linux gre les fichiers comme une arborescence structure de manire hirarchique. Mais ceci ne nous claire pas sur la faon dont sont stocks les fichiers et rpertoires sur le disque dur.
	</div>
		<br /><a class="summaryIndent0" href="#LI">I. Introduction</a>
			
			
		
		<br /><a class="summaryIndent0" href="#LII">II. Dfinition d'un systme de fichiers</a>
			
			
			
		
		<br /><a class="summaryIndent0" href="#LIII">III. Structure physique</a>
			
			
			
			
		
		<br /><a class="summaryIndent0" href="#LIV">IV. Constitution d'un systme de fichiers</a>
			
			
			
			
			
			
			
			
			
			
			
			
			
		
	<br/><br/>
		<br /><h1 class="TitreSection0" id="LI">I. Introduction</h1>
			
			<div class="paragraph">
				L'<a href="http://http://gfx.developpez.com/linux/kernel/" class="lienArticle">article prcdent</a> portait sur la compilation du noyau. Si vous avez tent l'aventure, la question des types de systmes de fichiers  intgrer au noyau vous a srement quelque peu interloqu. Linux connat en effet plusieurs types de systme de fichiers tels que l'Extended File System version 2 ou le Reiser File System. Mais avant d'tudier plus avant la gestion interne des fichiers sous Linux, il convient de faire la distinction entre une arborescence et un systme de fichiers.
			</div><br/>
		
		<br /><h1 class="TitreSection0" id="LII">II. Dfinition d'un systme de fichiers</h1>
			
			<div class="paragraph">
    			La notion d'arborescence dsigne la reprsentation logique des fichiers et des rpertoires telle qu'elle apparat au final pour l'utilisateur du systme. Une telle reprsentation est incarne par un arbre, donc par une succession de noeuds ramifis. Chaque noeud peut reprsenter un rpertoire ou un fichier. La notion de rpertoire va bien au-del de celle lie au systme Windows par exemple.
                En effet, un noeud peut contenir tout un systme de fichiers ! Ainsi un support amovible tel qu'un CD-Rom ou une disquette se voit prsent dans l'arborescence, usuellement dans le rpertoire /mnt. Ainsi, dans une distribution Red Hat, le rpertoire /mnt/cdrom contient en ralit non pas des donnes prsentes sur le disque dur, mais un systme de fichiers de type CD-Rom (iso9660, Joliet...). Un systme de fichiers est donc une reprsentation logique et structure des donnes physiques d'un mdia. Le systmes de fichiers dvoilent alors toute leur puissance: un mdia amovible, un ordinateur distant, toute source de ioudonnes peut tre intgre au sein de l'arborescence. On obtient au final une impression d'homognit des donnes accessibles. Voici une liste non exhaustive des systmes de fichiers existant sous Linux:
			</div><br/>
			<ul style="list-style-type: disc;">
				<li>ext2fs: Le systme de fichiers le plus employ sous Linux. Il est le successeur de l'extfs.</li>
				<li>isofs: Le ISO FS est le systme de fichiers pour les CD-Rom  la norme ISO-9660.</li>
				<li>minixfs: Le systme de fichiers de l'anctre de Linux, Minix.</li>
				<li>msdosfs: Offre un accs aux lecteurs DOS.</li>
				<li>nfs: Systme utilis par tous les Unix pour intgrer  l'arborescence un ordinateur distant.</li>
				<li>proc: Pseudo-systme de fichiers donnant des informations sur le noyau.</li>
				<li>vfat: Systme de fichiers de type VFAT (Windows 95...)</li>
			</ul>
		
		<br /><h1 class="TitreSection0" id="LIII">III. Structure physique</h1>
			
			<div class="paragraph">
				La description exacte d'un systme de fichiers dpend bien videmment du support utilis. Un systme de fichiers comme le NFS (Network File System) ne fonctionnera videmment pas comme le ext2fs standard. Nous allons nous concentrer uniquement sur la structure physique d'un systme de fichiers reprsentant un disque dur ou une partie de disque dur. L'espace disponible sur un disque dur est exprim en blocs. Chaque bloc a une taille de 512 octets. Chacun de ces blocs possde un numro et le contrleur du disque dur s'arrange pour les numroter de manire continue. Cette numrotation permet d'obtenir la position d'un bloc sur le support en fonction de son numro. Ainsi, le bloc numrot 2048 sera le 2048-ime sur le disque. A partir de cette information, le contrleur est en mesure de situer le bloc exactement  la surface du disque en jouant sur la division physique du disque. Un disque dur est en effet constitu d'une " pile " de plateaux. Or, chacun de ces plateaux est divis en secteurs, sortes de " tranches " partant du moyeu, et en piste. Les intersections des pistes et des secteurs forment les fameux blocs (voir figure 1).
			</div><br/>
			<div class="paragraph">
                Hlas, tout cela serait bien trop simple si tous les systmes de fichiers possdaient le mme dcoupage des blocs physiques en blocs dits logiques. Chaque type de systme regroupe plusieurs blocs physiques en un seul logique. Le seul point commun entre tous les systmes de fichiers correspond aux nombre de blocs physiques utiliss qui eux possdent la taille fixe de 512 octets. Ainsi, la dnomination " bloc " correspondra dans la suite de cet article  un bloc logique.
			</div><br/>
			<div class="image" style="text-align:center;"><img src="./images/figure1.png" alt=""/><div style="text-align:center;" class="legimage">Structure physique d'un disque dur.</div></div>
		
		<br /><h1 class="TitreSection0" id="LIV">IV. Constitution d'un systme de fichiers</h1>
			
			<div class="paragraph">
				Eu gard la grande diversit des systmes de fichiers disponibles, il y a peu de chances qu'un systme possdent beaucoup de points communs avec un autre. Nous resserrerons donc notre tude sur le type ext2fs exclusivement. Ce dernier possde les caractristiques suivantes:
			</div><br/>
			<ul style="list-style-type: disc;">
				<li>un bloc d'amorage</li>
				<li>un superbloc</li>
				<li>une table des inodes</li>
				<li>des blocs de donnes</li>
			</ul>
			<div class="paragraph">
				Le bloc d'amorage est le premier, numrot 0, d'un systme de fichiers. Il peut contenir un programme charger d'initialiser le systme. Normalement, seul le premier systme de fichiers, si plusieurs partitions existent, possde un bloc d'amorage non vide. Dans le cas du systme ext2fs, la taille de ce bloc est de 1024 octets, soit un kilo octet. A la suite du bloc d'amorage, ce trouvent des groupes de blocs. Chaque groupe contient un superbloc, suivi d'une description des groupes de blocs, puis d'informations sur les blocs ou inodes occups et enfin viennent la table des inodes et les blocs de donnes (voir figure 2). Nombreux sont ceux qui doivent connatre la signification de " inode ". Sous Linux, un inode est destin  grer les informations d'un objet du systme de fichiers. Par exemple, ce sont les inodes qui grent les droits d'accs ou les liens symboliques.
			</div><br/>
			<div class="image" style="text-align:center;"><img src="./images/figure2.png" alt=""/><div style="text-align:center;" class="legimage">Rpartition des blocs logiques.</div></div>
			<div class="paragraph">
                Comme nous venons de le voir, un groupe de blocs contient six lments (les informations des blocs et inodes comptant pour deux sur la figure ci-dessus). Le systme ext2fs est donc constitu d 'une multitude de groupes de blocs dont la taille est de 8 192 blocs dont 2 048 inodes. Parmi ces derniers, les 8 premiers sont rservs par le systme. Il en reste donc 2 040  disposition de l'utilisateur.
			</div><br/>
			<div class="paragraph">
                Le superbloc contient toutes les informations concernant le systme de fichier. En cas d'erreur sur un superbloc, il est possible de rcuprer ces informations sur un autre. Voici les informations les plus importantes que l'on peut trouver au sein d'un superbloc:
			</div><br/>
			<ul style="list-style-type: disc;">
				<li>taille totale du systme de fichiers, en blocs et inodes</li>
				<li>nombre de blocs libres</li>
				<li>nombre de blocs rservs aux inodes</li>
				<li>taille d'un bloc de donnes</li>
				<li>heure de la dernire modification effectue</li>
				<li>heure de dernire vrification du systme de fichiers</li>
			</ul>
			<div class="paragraph">
				La liste de description des groupes de blocs facilite l'accs aux blocs de donnes. Cette liste dfinit les blocs physiques contenant les blocs de donnes, les inodes. Elle rpertorie galement le nombre de blocs ou d'inodes libres.
			</div><br/>
			<div class="paragraph">
                Les informations des blocs et des inodes est une image binaire de l'occupation des blocs et inodes. Codes sur 1024 octets, ces informations indiquent un bit mis  0 pour un bloc libre ou  1 pour un bloc utilis. Avec ces 1024 octets, il est possible de se renseigner sur l'tat de 8 192 blocs ou inodes. On retrouve ici la limite d'un groupe de blocs.
			</div><br/>
			<div class="paragraph">
                La table des inodes rpertorie les 2 048 inodes les uns  la suite des autres. Un inode est essentiel pour permettre l'accs aux fichiers car il dcrit toutes les caractristiques d'un fichier donn. Pour chaque fichier enregistr sur le disque dur, un inode est associ. Ainsi un inode peut stocker les informations suivantes:
			</div><br/>
			<ul style="list-style-type: disc;">
				<li>identification du propritaire</li>
				<li>taille en octets</li>
				<li>heures de modification/cration/accs</li>
				<li>nombre de liens lis  ce fichier</li>
				<li>type de fichier: classique, rpertoire, lien symbolique...</li>
				<li>droits d'accs</li>
			</ul>
			<div class="paragraph">
				Enfin, les blocs de donnes occupent l'espace compris entre la fin de la table des inodes jusqu' la fin du groupes de blocs. Chaque bloc de donnes a exactement la taille d'un bloc logique. Vous l'aurez compris, ce sont les blocs de donnes eux mmes qui renferment les donnes de votre ordinateur. Les accs aux blocs de donnes sont possibles grce  la table d'adressage des blocs de donnes. Cette table contient en tout et pour tout 15 enregistrements. Chacun d'entre eux renvoie  un bloc de donnes. La structure des ces enregistrements permet d'adresser un total de 16,6 Go, ce qui est la limite d'une partition ext2fs. Outre cette limitation, le fait que la rfrence au prochain caractre  lire ou  crire soit indique par un entier non sign de 32 bits limite la taille d'un fichier  2^32, soit 4 294 967 295 octets. C'est  dire 4 Go.
			</div><br/>
		
	<br/><hr/><p style="text-align:center;"><a href="http://validator.w3.org/check?uri=referer"><img src="http://www.w3.org/Icons/valid-xhtml11" alt="Valid XHTML 1.1!" height="31" width="88"/></a><a href="http://jigsaw.w3.org/css-validator/check/referer"><img style="border:0;width:88px;height:31px" src="http://jigsaw.w3.org/css-validator/images/vcss" alt="Valid CSS!"/></a></p><div class="licence">
        Cette cration est mise  disposition sous un <a href="http://creativecommons.org/licenses/by-sa/2.5/" class="lienArticle">contrat Creative Commons</a> (Paternit - Partage des Conditions Initiales  l'Identique).
	</div>
	  </td>
		</tr>
		   </table></div>
<?
	include("$DOCUMENT_ROOT/template/pied.php");?>